unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtDlgs, ExtCtrls;

type
  TForm1 = class(TForm)
    btFont: TButton;
    Memo1: TMemo;
    edVstup: TEdit;
    btJinaMapa: TButton;
    OpenDialog1: TOpenDialog;
    FontDialog1: TFontDialog;
    btStart: TButton;                           // startovni cislo 2
    lbRozmer: TLabel;
    lbPopisek: TLabel;
    btKonec: TButton;
    lbPopisek2: TLabel;
    edTXT: TEdit;
    Button1: TButton;
    Bevel1: TBevel;
    Memo2: TMemo;
    Button2: TButton;
    SaveDialog1: TSaveDialog;
    procedure btFontClick(Sender: TObject);
    procedure btJinaMapaClick(Sender: TObject);
    procedure btStartClick(Sender: TObject);
    procedure btKonecClick(Sender: TObject);
    function najdiX(x,y,mx,my,mx1,my1 : integer; co : char):integer;
    function najdiY(x,y,mx,my,mx1,my1 : integer; co : char):integer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    mapa : array[0..260,0..260]of Char; //dal jsem si rezervu
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.dfm}

procedure TForm1.btFontClick(Sender: TObject);
begin
  if FontDialog1.Execute then
  Memo1.Font := FontDialog1.Font;
end;

procedure TForm1.btJinaMapaClick(Sender: TObject);
begin
  if  OpenDialog1.Execute then
   begin
    edVstup.Text :=  OpenDialog1.FileName;
   end;
end;

procedure TForm1.btStartClick(Sender: TObject);
var t,vys : textfile;
   znak : char;
   x,y,mx,my,mx1,my1,nx,ny,jedex,jedey : integer;         // souradnice x,y
   delka : integer;                                         // mx,my,mx1,my1 - starsi souradnice
   radek : string;                                          // nx,ny nove souradnice
   startx : integer;                                       //jedex, jedey - o kolik se uz posouva
   starty : integer;
   jedenpx : integer;
begin
  Memo1.Clear;
  x:=1;
  y:=1;
  AssignFile(t,edVstup.Text);
  Reset(t);

  while not Eof(t) do
  begin
   Readln(t,radek);
   delka := length(radek);
   Memo1.Lines.Add(IntToStr(delka-y+1)+' '+radek);
   while not (x > delka) do
   begin
     znak := radek[x];
     case znak of
       'S' : begin startx:=x; starty:=y; end;
     end;
     mapa[x,y] := znak;   // vyvroreni "mapy"
     x:=x+1;
   end;
   x:=1;
   y:=y+1;
  end;
  lbRozmer.Caption := 'Rozmr mapy : '+IntToStr(delka)+' x '+IntToStr(y-1);
  CloseFile(t);
  ///**************************************
  AssignFile(vys,edTXT.Text);
  Rewrite(vys);

   jedex:=0;
   jedey:=0;

  mx:=0;
  my:=0;
  mx1:=0;
  my1:=0;
  x:= startx;
  y:= starty;
  repeat
   nx := najdiX(x,y,mx,my,mx1,my1,':');
   ny := najdiY(x,y,mx,my,mx1,my1,':');
   if not ((nx=260) OR (ny=260)) then
   begin
     radek := IntToStr(((nx-x)-jedex))+','+IntToStr(-((ny-y)-jedey));
     Writeln(vys,radek);
     Memo2.Lines.Add(radek);
     jedex:=jedex+((nx-x)-jedex);
     jedey:=jedey+((ny-y)-jedey);
     mapa[nx,ny] := 'N';                   //hled a hled dal dvojteky
   end;
     mx1:=mx;
     my1:=my;
     mx:=x;
     my:=y;
     x:=nx;
     y:=ny;
  until nx=260;


   x:=mx;
   y:=my;
   nx := najdiX(x,y,0,0,0,0,'C');            //najde cl
   ny := najdiY(mx,y,0,0,0,0,'C');
   radek := IntToStr(((nx-x)-jedex))+','+IntToStr(-((ny-y)-jedey));
   Writeln(vys,radek);
   Memo2.Lines.Add(radek);
   mapa[nx,ny] := 'Q';


  CloseFile(vys);

  //vykresleni
  Form2.Image1.Canvas.Brush.Color := clMoneyGreen;
  Form2.Image1.Canvas.FillRect(Form2.Image1.ClientRect);
  jedenpx := 600 div delka;
  for y:=1 to delka do
  for x:=1 to delka do
  begin
    case mapa[x,y]of
    'X' : Form2.Image1.Canvas.Brush.Color := clMoneyGreen;
    '.' : Form2.Image1.Canvas.Brush.Color := clBlue;
    ':' : Form2.Image1.Canvas.Brush.Color := clNavy;
    'C' : Form2.Image1.Canvas.Brush.Color := clRed;
    'N' : Form2.Image1.Canvas.Brush.Color := clWhite;
    'Q' : Form2.Image1.Canvas.Brush.Color := clYellow;
    end;
    case mapa[x,y]of
    'X' : Form2.Image1.Canvas.Pen.Color := clMoneyGreen;         //nastaveni barev
    '.' : Form2.Image1.Canvas.Pen.Color := clBlue;
    ':' : Form2.Image1.Canvas.Pen.Color := clNavy;
    'C' : Form2.Image1.Canvas.Pen.Color := clRed;
    'N' : Form2.Image1.Canvas.Pen.Color := clWhite;
    'Q' : Form2.Image1.Canvas.Pen.Color := clYellow;
    end;
    Form2.Image1.Canvas.Rectangle((x-1)*jedenpx,(y-1)*jedenpx,x*jedenpx,y*jedenpx);
  end;
  Form2.ShowModal;
end;

function Tform1.najdiX(x,y,mx,my,mx1,my1 : integer; co : char):integer;
begin
  if ((mapa[x-1,y+1] = co) and ((x-1 <> mx) OR (y+1 <> my)) and ((x-1 <> mx1) OR (y+1 <> my1))) then result := x-1 else
  if ((mapa[x-1,y  ] = co) and ((x-1 <> mx) OR (y   <> my)) and ((x-1 <> mx1) OR (y   <> my1))) then result := x-1 else
  if ((mapa[x-1,y-1] = co) and ((x-1 <> mx) OR (y-1 <> my)) and ((x-1 <> mx1) OR (y-1 <> my1))) then result := x-1 else
  if ((mapa[x,y+1  ] = co) and ((x   <> mx) OR (y+1 <> my)) and ((x   <> mx1) OR (y+1 <> my1))) then result := x   else
  if ((mapa[x,y-1  ] = co) and ((x   <> mx) OR (y-1 <> my)) and ((x   <> mx1) OR (y-1 <> my1))) then result := x   else
  if ((mapa[x+1,y+1] = co) and ((x+1 <> mx) OR (y+1 <> my)) and ((x+1 <> mx1) OR (y+1 <> my1))) then result := x+1 else
  if ((mapa[x+1,y  ] = co) and ((x+1 <> mx) OR (y   <> my)) and ((x+1 <> mx1) OR (y   <> my1))) then result := x+1 else
  if ((mapa[x+1,y-1] = co) and ((x+1 <> mx) OR (y-1 <> my)) and ((x+1 <> mx1) OR (y-1 <> my1))) then Result := x+1 else
  Result := 260;
end;                                           //tyto funkce najdou msto kde kde je dal dvojteka nesm to bt pedchoz ani pedpedchoz polko
                                               // kdy se nic nenajde tak vrati 260 - to je cil nebo spatne zdana mapa
function Tform1.najdiY(x,y,mx,my,mx1,my1 : integer; co : char):integer;
begin
  if ((mapa[x-1,y+1] = co) and ((x-1 <> mx) OR (y+1 <> my)) and ((x-1 <> mx1) OR (y+1 <> my1))) then result := y+1 else
  if ((mapa[x-1,y  ] = co) and ((x-1 <> mx) OR (y   <> my)) and ((x-1 <> mx1) OR (y   <> my1))) then result := y   else
  if ((mapa[x-1,y-1] = co) and ((x-1 <> mx) OR (y-1 <> my)) and ((x-1 <> mx1) OR (y-1 <> my1))) then result := y-1 else
  if ((mapa[x,y+1  ] = co) and ((x   <> mx) OR (y+1 <> my)) and ((x   <> mx1) OR (y+1 <> my1))) then result := y+1 else
  if ((mapa[x,y-1  ] = co) and ((x   <> mx) OR (y-1 <> my)) and ((x   <> mx1) OR (y-1 <> my1))) then result := y-1 else
  if ((mapa[x+1,y+1] = co) and ((x+1 <> mx) OR (y+1 <> my)) and ((x+1 <> mx1) OR (y+1 <> my1))) then result := y+1 else
  if ((mapa[x+1,y  ] = co) and ((x+1 <> mx) OR (y   <> my)) and ((x+1 <> mx1) OR (y   <> my1))) then result := y   else
  if ((mapa[x+1,y-1] = co) and ((x+1 <> mx) OR (y-1 <> my)) and ((x+1 <> mx1) OR (y-1 <> my1))) then result := y-1 else
  Result := 260;
end;

procedure TForm1.btKonecClick(Sender: TObject);
begin
  close;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if SaveDialog1.Execute then
  edTXT.Text := SaveDialog1.FileName+'.txt';
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Form2.ShowModal;
end;

end.
